---
title: font
slug: Web/CSS/font
tags:
  - CSS
  - CSS Fonts
  - CSS Property
  - Reference
  - 'recipe:css-shorthand-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>font</code></strong> CSS <a href="/en-US/docs/Web/CSS/Shorthand_properties">shorthand property</a> sets all the different properties of an element's font. Alternatively, it sets an element's font to a system font.</p>

<div>{{EmbedInteractiveExample("pages/css/font.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>As with any shorthand property, any individual value that is not specified is set to its corresponding initial value (possibly overriding values previously set using non-shorthand properties). Though not directly settable by <code>font</code>, the longhands {{cssxref("font-size-adjust")}} and {{cssxref("font-kerning")}} are also reset to their initial values.</p>

<h2 id="Constituent_properties">Constituent properties</h2>

<p>This property is a shorthand for the following CSS properties:</p>

<ul>
 <li>{{cssxref("font-family")}}</li>
 <li>{{cssxref("font-size")}}</li>
 <li>{{cssxref("font-stretch")}}</li>
 <li>{{cssxref("font-style")}}</li>
 <li>{{cssxref("font-variant")}}</li>
 <li>{{cssxref("font-weight")}}</li>
 <li>{{cssxref("line-height")}}</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<p>The <code>font</code> property may be specified as either a single keyword, which will select a system font, or as a shorthand for various font-related properties.</p>

<p>If <code>font</code> is specified as a system keyword, it must be one of: <code><a href="#caption">caption</a></code>, <code><a href="#icon">icon</a></code>, <code><a href="#menu">menu</a></code>, <code><a href="#message-box">message-box</a></code>, <code><a href="#small-caption">small-caption</a></code>, <code><a href="#status-bar">status-bar</a></code>.</p>

<p>If <code>font</code> is specified as a shorthand for several font-related properties, then:</p>

<ul>
 <li>it must include values for:
  <ul>
   <li>{{cssxref("&lt;font-size&gt;")}}</li>
   <li>{{cssxref("&lt;font-family&gt;")}}</li>
  </ul>
 </li>
 <li>it may optionally include values for:
  <ul>
   <li>{{cssxref("&lt;font-style&gt;")}}</li>
   <li>{{cssxref("&lt;font-variant&gt;")}}</li>
   <li>{{cssxref("&lt;font-weight&gt;")}}</li>
   <li>{{cssxref("&lt;font-stretch&gt;")}}</li>
   <li>{{cssxref("&lt;line-height&gt;")}}</li>
  </ul>
 </li>
 <li><code>font-style</code>, <code>font-variant</code> and <code>font-weight</code> must precede <code>font-size</code></li>
 <li><code>font-variant</code> may only specify the values defined in CSS 2.1, that is <code>normal</code> and <code>small-caps</code></li>
 <li><code>font-stretch</code> may only be a single keyword value.</li>
 <li><code>line-height</code> must immediately follow <code>font-size</code>, preceded by "/", like this: "<code>16px/3</code>"</li>
 <li><code>font-family</code> must be the last value specified.</li>
</ul>

<h3 id="Values">Values</h3>

<dl>
 <dt id="&lt;'font-style'&gt;"><code>&lt;'font-style'&gt;</code></dt>
 <dd>See the {{cssxref("font-style")}} CSS property.</dd>
 <dt id="&lt;'font-variant'&gt;"><code>&lt;'font-variant'&gt;</code></dt>
 <dd>See the {{cssxref("font-variant")}} CSS property.</dd>
 <dt id="&lt;'font-weight'&gt;"><code>&lt;'font-weight'&gt;</code></dt>
 <dd>See the {{cssxref("font-weight")}} CSS property.</dd>
 <dt id="&lt;'font-stretch'&gt;"><code>&lt;'font-stretch'&gt;</code></dt>
 <dd>See the {{cssxref("font-stretch")}} CSS property.</dd>
 <dt id="&lt;'font-size'&gt;"><code>&lt;'font-size'&gt;</code></dt>
 <dd>See the {{cssxref("font-size")}} CSS property.</dd>
 <dt id="&lt;'line-height'&gt;"><code>&lt;'line-height'&gt;</code></dt>
 <dd>See the {{cssxref("line-height")}} CSS property.</dd>
 <dt id="&lt;'font-family'&gt;"><code>&lt;'font-family'&gt;</code></dt>
 <dd>See the {{cssxref("font-family")}} CSS property.</dd>
</dl>

<h4 id="System_font_values">System font values</h4>

<dl>
 <dt id="caption"><code>caption</code></dt>
 <dd>The system font used for captioned controls (e.g., buttons, drop-downs, etc.).</dd>
 <dt id="icon"><code>icon</code></dt>
 <dd>The system font used to label icons.</dd>
 <dt id="menu"><code>menu</code></dt>
 <dd>The system font used in menus (e.g., dropdown menus and menu lists).</dd>
 <dt id="message-box"><code>message-box</code></dt>
 <dd>The system font used in dialog boxes.</dd>
 <dt id="small-caption"><code>small-caption</code></dt>
 <dd>The system font used for labeling small controls.</dd>
 <dt id="status-bar"><code>status-bar</code></dt>
 <dd>The system font used in window status bars.</dd>
 <dt>Prefixed system font keywords</dt>
 <dd>Browsers often implement several more, prefixed, keywords: Gecko implements <code>-moz-window</code>, <code>-moz-document</code>, <code>-moz-desktop</code>, <code>-moz-info</code>, <code>-moz-dialog</code>, <code>-moz-button</code>, <code>-moz-pull-down-menu</code>, <code>-moz-list</code>, and <code>-moz-field</code>.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_font_properties">Setting font properties</h3>

<pre class="brush: css notranslate">/* Set the font size to 12px and the line height to 14px.
   Set the font family to sans-serif */
p { font: 12px/14px sans-serif }

/* Set the font size to 80% of the parent element
   or default value (if no parent element present).
   Set the font family to sans-serif */
p { font: 80% sans-serif }

/* Set the font weight to bold,
   the font-style to italic,
   the font size to large,
   and the font family to serif. */
p { font: bold italic large serif }

/* Use the same font as the status bar of the window */
p { font: status-bar }
</pre>

<h3 id="live_sample">Live sample</h3>

<div class="hidden">
<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;p&gt;
    Change the radio buttons below to see the generated shorthand and it's effect.
&lt;/p&gt;
&lt;form action="createShortHand()"&gt;
    &lt;div class="cf"&gt;
        &lt;div class="setPropCont"&gt;
            font-style&lt;br/&gt;
            &lt;input type="radio" id="font-style-none" name="font_style" checked="" value="" onchange="setCss()"&gt; &lt;label for="font-style-none"&gt;none&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-style-normal" name="font_style" value="normal" onchange="setCss()"&gt; &lt;label for="font-style-normal"&gt;normal&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-style-italic" name="font_style" value="italic" onchange="setCss()"&gt; &lt;label for="font-style-italic"&gt;italic&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-style-oblique" name="font_style" value="oblique" onchange="setCss()"&gt; &lt;label for="font-style-oblique"&gt;oblique&lt;/label&gt;
        &lt;/div&gt;

        &lt;div class="setPropCont"&gt;
            font-variant&lt;br&gt;
            &lt;input type="radio" id="font-variant-none" name="font_variant" checked="" value=" " onchange="setCss()"&gt; &lt;label for="font-variant-none"&gt;none&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-variant-normal" name="font_variant" value="normal" onchange="setCss()"&gt; &lt;label for="font-variant-normal"&gt;normal&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-variant-small-caps" name="font_variant" value="small-caps" onchange="setCss()"&gt; &lt;label for="font-variant-small-caps"&gt;small-caps&lt;/label&gt;
        &lt;/div&gt;

        &lt;div class="setPropCont"&gt;
            font-weight&lt;br/&gt;
            &lt;input type="radio" id="font-weight-none" name="font_weight" value="" onchange="setCss()"&gt; &lt;label for="font-weight-none"&gt;none&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-weight-normal" checked="" name="font_weight" value="400" onchange="setCss()"&gt; &lt;label for="font-weight-normal"&gt;normal&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-weight-bold" name="font_weight" value="700" onchange="setCss()"&gt; &lt;label for="font-weight-bold"&gt;bold&lt;/label&gt;
        &lt;/div&gt;

        &lt;div class="setPropCont"&gt;
            font-size&lt;br/&gt;
            &lt;input type="radio" id="font-size-12px" name="font_size" value="12px" onchange="setCss()"&gt; &lt;label for="font-size-12px"&gt;12px&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-size-16px" name="font_size" value="16px" checked="" onchange="setCss()"&gt; &lt;label for="font-size-16px"&gt;16px&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="font-size-24px" name="font_size" value="24px" onchange="setCss()"&gt; &lt;label for="font-size-24px"&gt;24px&lt;/label&gt;
        &lt;/div&gt;

        &lt;div class="setPropCont"&gt;
            line-height&lt;br/&gt;
            &lt;input type="radio" id="line-height-none" name="line_height" checked="" value="" onchange="setCss()"&gt; &lt;label for="line-height-none"&gt;none&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="line-height-1.2" name="line_height" value="/1.2" onchange="setCss()"&gt; &lt;label for="line-height-1.2"&gt;1.2&lt;/label&gt;&lt;br/&gt;
            &lt;input type="radio" id="line-height-3" name="line_height" value="/3" onchange="setCss()"&gt; &lt;label for="line-height-3"&gt;3&lt;/label&gt;
        &lt;/div&gt;&lt;br/&gt;

        &lt;div class="setPropCont fontfamily"&gt;
            font-family&lt;br/&gt;
            &lt;input type="radio" id="font-family-courier" name="font_family" checked="" value="courier" onchange="setCss(5,'courier')"&gt; &lt;label for="font-family-courier"&gt;courier&lt;/label&gt;&lt;br/&gt;            &lt;input type="radio" id="font-family-serif" name="font_family" value="serif" onchange="setCss()"&gt; &lt;label for="font-family-serif"&gt;serif&lt;/label&gt;&lt;br /&gt;
            &lt;input type="radio" id="font-family-sans-serif" name="font_family" value="sans-serif" onchange="setCss()"&gt; &lt;label for="font-family-sans-serif"&gt;sans-serif&lt;/label&gt;&lt;br /&gt;            &lt;input type="radio" id="font-family-arial" name="font_family" value="arial" onchange="setCss()"&gt; &lt;label for="font-family-arial"&gt;Arial&lt;/label&gt;&lt;br /&gt;
            &lt;input type="radio" id="font-family-monospace" name="font_family" value="monospace" onchange="setCss()"&gt; &lt;label for="font-family-monospace"&gt;monospace&lt;/label&gt;&lt;br /&gt;            &lt;input type="radio" id="font-family-cursive" name="font_family" value="cursive" onchange="setCss()"&gt; &lt;label for="font-family-cursive"&gt;cursive&lt;/label&gt;&lt;br /&gt;
            &lt;input type="radio" id="font-family-fantasy" name="font_family" value="fantasy" onchange="setCss()"&gt; &lt;label for="font-family-fantasy"&gt;fantasy&lt;/label&gt;&lt;br /&gt;            &lt;input type="radio" id="font-family-system-ui" name="font_family" value="system-ui" onchange="setCss()"&gt; &lt;label for="font-family-system-ui"&gt;system-ui&lt;/label&gt;&lt;br /&gt;
        &lt;/div&gt;
    &lt;/div&gt;

    &lt;div class="cf propInputs"&gt;
        &lt;div class="propInputCont tar"&gt;
            font :
        &lt;/div&gt;
        &lt;div class="propInputCont"&gt;
            &lt;input type="text" class="curCss" id="input_font_style"&gt;&lt;br/&gt;
            font-style &lt;br/&gt;
            optional

        &lt;/div&gt;
        &lt;div class="propInputCont"&gt;
            &lt;input type="text" class="curCss" id="input_font_variant"&gt; &lt;br/&gt;
            font-variant &lt;br/&gt;
            optional
        &lt;/div&gt;
        &lt;div class="propInputCont"&gt;
            &lt;input type="text" class="curCss" id="input_font_weight"&gt; &lt;br/&gt;
            font-weight &lt;br/&gt;
            optional
        &lt;/div&gt;
        &lt;div class="propInputCont"&gt;
            &lt;input type="text" class="curCss mandatory" id="input_font_size"&gt; &lt;br/&gt;
            font-size &lt;br/&gt;
            mandatory
        &lt;/div&gt;
        &lt;div class="propInputCont"&gt;
            &lt;input type="text" class="curCss" id="input_line_height"&gt; &lt;br/&gt;
            line-height &lt;br/&gt;
            optional
        &lt;/div&gt;
        &lt;div class="propInputCont"&gt;
            &lt;input type="text" class="curCss mandatory" id="input_font_family"&gt; &lt;br/&gt;
            font-family &lt;br/&gt;
            mandatory
        &lt;/div&gt;
    &lt;/div&gt;
&lt;/form&gt;

&lt;div class="fontShortHand"&gt;
    This is some sample text.
&lt;/div&gt;
&lt;br/&gt;&lt;br/&gt;&lt;br/&gt;&lt;br/&gt;&lt;br/&gt;&lt;br/&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">body, input {
  font: 14px arial;
  overflow: hidden;
}

.propInputCont {
  float: left;
  text-align: center;
  margin-right: 5px;
  width: 80px;
}

.setPropCont {
  float: left;
  margin-right: 5px;
  width: 120px;
}

.propInputs, .setPropCont {
  margin-bottom: 1em;
}

.curCss {
  border: none;
  border-bottom: 1px solid black;
  text-align: center;
  width: 80px;
}

.mandatory {
  border-bottom-color: red;
}

.cf:before,
.cf:after {
  content: " ";
  display: table;
}

.cf:after {
  clear: both;
}

.tar {
  width: 40px;
  text-align: right;
}
.fontfamily {
  display: inline-block;
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">var textAreas = document.getElementsByClassName("curCss"),
    shortText = "",
    getCheckedValue,
    setCss,
    getProperties,
    injectCss;

getProperties = function () {
  shortText =
      getCheckedValue("font_style") + " " +
      getCheckedValue("font_variant") + " " +
      getCheckedValue("font_weight") + " " +
      getCheckedValue("font_size") +
      getCheckedValue("line_height") + " " +
      getCheckedValue("font_family");

  return shortText;
}

getCheckedValue = function(radio_name) {
  oRadio = document.forms[0].elements[radio_name];
  for (var i = 0; i &lt; oRadio.length; i++) {
    if(oRadio[i].checked) {
      var propInput = "input_" + radio_name,
          curElemName = "input_" + radio_name,
          curElem = document.getElementById(curElemName);
      curElem.value = oRadio[i].value;

      return oRadio[i].value;
    }
  }
}

setCss = function () {
  getProperties();
  injectCss(shortText);
}

injectCss = function(cssFragment) {
  old = document.body.getElementsByTagName("style");
  if (old.length &gt; 1) {
    old[1].parentElement.removeChild(old[1]);
  }
  css = document.createElement("style");
  css.innerHTML = ".fontShortHand{font: " + cssFragment + "}";
  document.body.appendChild(css);
}

setCss();</pre>
</div>

<p>{{ EmbedLiveSample('live_sample','100%', '440px')}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Fonts', '#font-prop', 'font')}}</td>
   <td>{{Spec2('CSS3 Fonts')}}</td>
   <td>Added support for <code>font-stretch</code> values.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'fonts.html#font-shorthand', 'font-weight')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Added support for keywords.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS1', '#font', 'font')}}</td>
   <td>{{Spec2('CSS1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.font")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("font-style")}}</li>
 <li>{{cssxref("font-weight")}}</li>
 <li><a href="/en-US/docs/Learn/CSS/Styling_text/Fundamentals">Fundamental text and font styling</a></li>
</ul>
